Create object
curl --request POST \
--url https://api.roofkit.ai/api/v1/objects \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"template_key": "<string>",
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"slug": "<string>",
"description": "<string>"
}
'import requests
url = "https://api.roofkit.ai/api/v1/objects"
payload = {
"template_key": "<string>",
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"slug": "<string>",
"description": "<string>"
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
template_key: '<string>',
label_plural: '<string>',
label_singular: '<string>',
icon: '<string>',
color: '<string>',
slug: '<string>',
description: '<string>'
})
};
fetch('https://api.roofkit.ai/api/v1/objects', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.roofkit.ai/api/v1/objects",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'template_key' => '<string>',
'label_plural' => '<string>',
'label_singular' => '<string>',
'icon' => '<string>',
'color' => '<string>',
'slug' => '<string>',
'description' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.roofkit.ai/api/v1/objects"
payload := strings.NewReader("{\n \"template_key\": \"<string>\",\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"slug\": \"<string>\",\n \"description\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.roofkit.ai/api/v1/objects")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"template_key\": \"<string>\",\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"slug\": \"<string>\",\n \"description\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.roofkit.ai/api/v1/objects")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"template_key\": \"<string>\",\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"slug\": \"<string>\",\n \"description\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"slug": "<string>",
"seeded_status_field": {}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "FORBIDDEN",
"message": "API key does not include the required scope: leads.write.",
"request_id": "req_123",
"details": {
"required_scope": "leads.write",
"missing_scopes": [
"leads.write"
]
}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}Data Objects
Create object
Creates a custom Data Object from a template. Requires the data_tables plan entitlement. Built-in Contacts and Reports stay on their native modules.
POST
/
api
/
v1
/
objects
Create object
curl --request POST \
--url https://api.roofkit.ai/api/v1/objects \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"template_key": "<string>",
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"slug": "<string>",
"description": "<string>"
}
'import requests
url = "https://api.roofkit.ai/api/v1/objects"
payload = {
"template_key": "<string>",
"label_plural": "<string>",
"label_singular": "<string>",
"icon": "<string>",
"color": "<string>",
"slug": "<string>",
"description": "<string>"
}
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
template_key: '<string>',
label_plural: '<string>',
label_singular: '<string>',
icon: '<string>',
color: '<string>',
slug: '<string>',
description: '<string>'
})
};
fetch('https://api.roofkit.ai/api/v1/objects', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.roofkit.ai/api/v1/objects",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'template_key' => '<string>',
'label_plural' => '<string>',
'label_singular' => '<string>',
'icon' => '<string>',
'color' => '<string>',
'slug' => '<string>',
'description' => '<string>'
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.roofkit.ai/api/v1/objects"
payload := strings.NewReader("{\n \"template_key\": \"<string>\",\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"slug\": \"<string>\",\n \"description\": \"<string>\"\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.roofkit.ai/api/v1/objects")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"template_key\": \"<string>\",\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"slug\": \"<string>\",\n \"description\": \"<string>\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.roofkit.ai/api/v1/objects")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"template_key\": \"<string>\",\n \"label_plural\": \"<string>\",\n \"label_singular\": \"<string>\",\n \"icon\": \"<string>\",\n \"color\": \"<string>\",\n \"slug\": \"<string>\",\n \"description\": \"<string>\"\n}"
response = http.request(request)
puts response.read_body{
"id": "<string>",
"slug": "<string>",
"seeded_status_field": {}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "FORBIDDEN",
"message": "API key does not include the required scope: leads.write.",
"request_id": "req_123",
"details": {
"required_scope": "leads.write",
"missing_scopes": [
"leads.write"
]
}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "<string>",
"request_id": "<string>",
"details": {}
}
}Required scopes:
data_objects.schema.manageAuthorizations
Use Authorization: Bearer rk_live_....
Headers
A unique value for each new request, such as a UUID. Send the same value to retry a request safely. The same key and payload replay the first response with Idempotency-Replayed: true.
Required string length:
1 - 160Body
application/json
Maximum string length:
80Maximum string length:
120Maximum string length:
120Maximum string length:
80Maximum string length:
32Maximum string length:
80Maximum string length:
2000Available options:
table, kanban, list